<script setup lang="ts">
  import { Popover, PopoverButton, PopoverPanel, TransitionRoot } from '@headlessui/vue';
  import { useScrollLock } from '@vueuse/core';

  const props = withDefaults(
    defineProps<{
      fitPanel?: boolean;
      closeOnSelected?: boolean;
    }>(),
    {
      fitPanel: false,
      closeOnSelected: true,
    },
  );

  const btnRef = ref<HTMLElement>();
  const { getPanelStyling } = usePopover(btnRef, props.fitPanel);

  const $body = ref<HTMLElement | null>();
  const isLocked = useScrollLock($body);

  onMounted(() => {
    $body.value = document.body;
  });

  const handleBackdropClick = (e: Event, close: () => void) => {
    isLocked.value = false;
    if (props.closeOnSelected) return close();

    const curElement = e.target;

    const isInDropdownPanel = !!(curElement as HTMLElement)?.closest('.dropdown-panel');

    if (!isInDropdownPanel) close();
  };

  const handleClick = () => {
    isLocked.value = true;
  };
</script>

<template>
  <Popover v-slot="{ open, close }" class="relative">
    <PopoverButton as="div" @click="handleClick">
      <div ref="btnRef">
        <slot :open="open" name="trigger-button" />
      </div>
    </PopoverButton>

    <PopoverPanel>
      <Teleport to="body">
        <TransitionRoot
          appear
          as="template"
          :show="open"
          enter="transition duration-200 ease-out"
          enter-from="opacity-0"
          enter-to="opacity-100"
          leave="transition duration-150 ease-in"
          leave-from="opacity-100"
          leave-to="opacity-0"
        >
          <div
            class="z-backdrop fixed inset-0 h-full w-full bg-transparent"
            @click="(e) => handleBackdropClick(e, close)"
          >
            <div
              class="z-tooltip rounded-2 shadow-5 font-500 border-information-disabled dropdown-panel absolute right-0 z-10 flex flex-col gap-0.5 overflow-hidden border bg-white p-2 text-sm"
              :style="getPanelStyling()"
            >
              <slot name="content"></slot>
            </div>
          </div>
        </TransitionRoot>
      </Teleport>
    </PopoverPanel>
  </Popover>
</template>
